def plus_proche(ville, dist, visitees):
    """Renvoie le numéro de la ville 
    non encore visitées la plus proche 
    de la ville actuelle, en supposant
    qu'il en existe au moins une."""
    plus_proche = ""
    for i in range(len(visitees)):
        if not visitees[i]:
            if plus_proche == "" or dist[ville][i] < dist[ville][plus_proche]:
                plus_proche = i
    return plus_proche

def voyageur(villes, nomVilles, dist, depart):
    """Affiche les étapes du 
    parcours glouton depuis la 
    ville de départ. Et renvoie le 
    nombre total de km parcouru."""
    n = len(villes)
    visitees = [False] * n
    actuelle = depart
    km = 0
    texte = "\nVille de départ : " + nomVilles[depart]
    print(texte + "\n" + "-"*(len(texte)))
    print()
    for i in range(n-1):
        visitees[actuelle] = True
        suivante = plus_proche(actuelle, dist, visitees)
        print("On va de", nomVilles[actuelle], \
              "à", nomVilles[suivante], \
              "en", dist[actuelle][suivante], "km")
        km = km + dist[actuelle][suivante]
        actuelle = suivante
    print("On revient de", nomVilles[actuelle], \
          "à", nomVilles[depart], \
          "en", dist[actuelle][depart], "km")
    km = km + dist[actuelle][depart]
    return km

## Programme Main    
nomVilles = ['Nancy', 'Metz', 'Paris', 'Reims', 'Troyes']
lesVilles = [1, 2, 3, 4, 5]
lesDistances = [
 [0, 55, 303, 188, 183],
 [55, 0, 306, 176, 203],
 [303, 306, 0, 142, 153],
 [188, 176, 142, 0, 123],
 [183, 203, 153, 123, 0]
 ]
totalKm = voyageur(lesVilles, nomVilles, lesDistances, 4)
print("\nPour une distance totale de", totalKm, 'km.')